<?php
require '../../essential/bootstrap.php';

header( 'Content-Type: application/javascript' );

?>
/* Some settings */
var APP_ROOT_URL 	= <?php print json_encode(CDK_ROOT_URL); ?>;
var APP_AJAX_URL 	= <?php print json_encode(CDK_ROOT_URL . 'helpers/ajax/'); ?>;
var APP_DEBUG 		= <?php print json_encode(CDK_DEVELOPER_MODE); ?>;

/* App Space */
	//Alert messages stack
	function alertStack(alert_message,alert_type,alert_time,alert_title){
		var _alert_column;
		if( $("#_alert_column").length < 1)
			$("body").append("<div id='_alert_column'>");
		_alert_column = $("#_alert_column");
		
		if( !alert_type ) alert_type = '';
		if( !alert_time ) alert_time = 0;
		if( !alert_title ) alert_title = '';
		if( !alert_message ) alert_message = '';
		alert_message = alert_message.replace(/\n/g,"<br>");
		
		var animOpt = { duration:500,
					easing:'easeInExpo',
					complete:function(){ $(this).slideUp(1000,function(){$(this).remove();}); }
				};
		var el = $("<div>")
			.addClass("alert-stackable right-both ui-corner-all ")
			.addClass(alert_type);

		var title = $("<div>")
			.addClass("title ui-corner-all ui-state-default ui-state-hover")
			.appendTo(el);
			
			var text = $("<span>")
				.addClass("text")
				.text(alert_title)
				.appendTo(title);

			var close = $("<a>")
				.addClass("close right ui-corner-all ui-state-default ")
				.button({icons:{primary:'ui-icon-closethick'},text:false})
				//.hover(function(){ $(this).toggleClass("ui-state-hover"); })
				.click(function(){
					$(this).parents(".alert-stackable").animate({width:0,opacity:0},animOpt);
				})
				.appendTo(title);
			//close.append( $("<span>").addClass("ui-icon ui-icon-closethick") );
		var msg = $("<div>")
			.addClass("message")
			.html(alert_message)
			.appendTo(el);
		
		el
			.appendTo(_alert_column)
			.show({
				effect:"slide",
				duration:600,
				direction:'right',
				complete:function(){
					
					setTimeout(function(){
						
						$(el).animate({width:0,opacity:0},animOpt);
					},5000+alert_time);
					
				}
			});
		
	}
	
	
	// Alert Box
		var alert_box_selector 	= '#alert';
		var alert_box_speed 	= 1000;
		
		// Show Alert
		function AppShowAlert(message, type, timeout) {
			if(!message) return;
			
			if(  typeof(timeout) == undefined ) { var timeout = 0;	}
			if(  typeof(type) 	 == undefined )	{ var type = 'red';	}
			
			$(alert_box_selector + ' .message').html('').html(message);
			$(alert_box_selector).removeClass().addClass(type).show();
		
			if(timeout) $(alert_box_selector).delay(timeout).fadeOut(alert_box_speed);
		}
		// Close Alert
		$(alert_box_selector + ' .close' ).live( 'click', function() {
			$(alert_box_selector).hide();
		});
		
		function AppShowAlertDebug(message) {
			if(APP_DEBUG) {
				AppShowAlert(message, 'green', 3000);
				console.log(message);
			}
		}
		
		// Hard panic e reload
		function AppPanicAndReload(message) {
			alert('Purtroppo è avvenuto un errore durante la comunicazione con il server, sarà necessario ricominciare. Ci scusiamo per l\'inconveniente.' + "\nCodice errore: " + message);
			location.reload();
		}
		
// Javascript Helpers
	function ucwords(str) {
		return (str + '').replace(/^([a-z])|\s+([a-z])/g, function ($1) { return $1.toUpperCase(); });
	}

	function urlencode(str) {
		str = (str + '').toString();
		return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').
		replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/%20/g, '+');
	}

	function validate_email_address(str) {
		 str = (str + '').toString();
		 var regex = /^[-a-z0-9~!$%^&*_=+}{\'?]+(\.[-a-z0-9~!$%^&*_=+}{\'?]+)*@([a-z0-9_][-a-z0-9_]*(\.[-a-z0-9_]+)*\.(aero|arpa|biz|com|coop|edu|gov|info|int|mil|museum|name|net|org|pro|travel|mobi|[a-z][a-z])|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,5})?$/i;
		 return regex.test(str);
	}
	
	function addInputHighlights(array) {
		$.each( array, function(x, _name) {
			$('#' + _name).addClass('input-highlight');				
		});
	}
	
